diff --git a/acinclude.m4 b/acinclude.m4
index e9c5a5d..3561e16 100644
--- a/acinclude.m4
+++ b/acinclude.m4
@@ -324,6 +324,48 @@ AC_DEFUN([LOCATE_SPHINX],
 ])
 AC_SUBST(SPHINX_BUILD)
 
+##################
+# Locate libssh2 #
+##################
+AC_DEFUN([LOCATE_LIBSSH2],
+[
+	AC_ARG_WITH(libssh2, [  --with-libssh2=DIR  root directory for libssh2 installation],
+	[
+		if test "$withval" != no
+		then
+			LIBSSH2_HOME="$withval"
+			if test ! -f "${LIBSSH2_HOME}/include/libssh2.h"
+			then
+				AC_MSG_ERROR([Could not find your LIBSSH2 installation in ${LIBSSH2_HOME}])
+			else
+				LIBSSH2_INCLUDE=-I${LIBSSH2_HOME}/include
+				LIBSSH2_LIB=-L${LIBSSH2_HOME}/lib
+			fi
+		fi
+	],
+	[
+		LIBSSH2_HOME=/usr/local
+		if test ! -f "${LIBSSH2_HOME}/include/libssh2.h"
+		then
+			LIBSSH2_HOME=/usr
+			if test ! -f "${LIBSSH2_HOME}/include/libssh2.h"
+			then
+				LIBSSH2_HOME=/mingw
+				if test ! -f "${LIBSSH2_HOME}/include/libssh2.h"
+				then
+					AC_MSG_ERROR([Could not find your LIBSSH2 installation. You might need to use the --with-libssh2=DIR configure option])
+				fi
+			fi
+		fi
+
+		LIBSSH2_INCLUDE=-I${LIBSSH2_HOME}/include
+		LIBSSH2_LIB=-L${LIBSSH2_HOME}/lib
+	])
+
+	CPPFLAGS="${CPPFLAGS} ${LIBSSH2_INCLUDE}"
+	LDFLAGS="${LDFLAGS} ${LIBSSH2_LIB}"
+])
+
 ########################################
 # Enable Database Designer in pgAdmin3 #
 ########################################
@@ -720,6 +762,42 @@ AC_DEFUN([CHECK_EDB_LIBPQ],
 AC_SUBST(EDB_LIBPQ)
 
 ################################################
+# Check session handshake function in libssh2  #
+################################################
+AC_DEFUN([CHECK_LIBSSH2_HANDSHAKE_FUNC],
+[
+	AC_LANG_SAVE
+	AC_LANG_C
+	AC_CHECK_LIB(ssh2, libssh2_session_handshake, [HAVE_LIBSSH2_HANDSHAKE_FUNC=yes], [HAVE_LIBSSH2_HANDSHAKE_FUNC=no])
+	AC_LANG_RESTORE
+])
+AC_SUBST(LIBSSH2_HANDSHAKE_FUNC)
+
+###################################
+# Check exit function in libssh2  #
+###################################
+AC_DEFUN([CHECK_LIBSSH2_EXIT_FUNC],
+[
+	AC_LANG_SAVE
+	AC_LANG_C
+	AC_CHECK_LIB(ssh2, libssh2_exit, [HAVE_LIBSSH2_EXIT_FUNC=yes], [HAVE_LIBSSH2_EXIT_FUNC=no])
+	AC_LANG_RESTORE
+])
+AC_SUBST(LIBSSH2_EXIT_FUNC)
+
+##########################################
+# Check SSL library linked with libssh2  #
+##########################################
+AC_DEFUN([CHECK_LIBSSH2_CRYPTO_LIBRARY],
+[
+	AC_LANG_SAVE
+	AC_LANG_C
+	AC_CHECK_LIB(ssh2, libssh2_md5, [IS_LIBSSH2_OPENSSL_CRYPTO=yes], [IS_LIBSSH2_OPENSSL_CRYPTO=no])
+	AC_LANG_RESTORE
+])
+AC_SUBST(LIBSSH2_CRYPTO_LIBRARY)
+
+################################################
 # Check for wxWidgets libraries and headers	#
 ################################################
 AC_DEFUN([SETUP_WXWIDGETS],
@@ -847,6 +925,18 @@ AC_SUBST(XSLT_CONFIG)
 AC_SUBST(pgadmin3_LDADD)
 
 #########################
+# Setup libssh2 headers #
+#########################
+AC_DEFUN([SETUP_LIBSSH2],
+[
+	if test -n "${LIBSSH2_HOME}"
+	then
+		pgadmin3_LDADD="${pgadmin3_LDADD} -L$LIBSSH2_HOME/lib -lssh2"
+	fi
+])
+AC_SUBST(pgadmin3_LDADD)
+
+#########################
 # Configuration summary #
 #########################
 AC_DEFUN([SUMMARY],
@@ -882,6 +972,9 @@ AC_DEFUN([SUMMARY],
 	echo "libxslt xslt-config binary:		$XSLT_CONFIG"
 	echo "libxslt version:			libxslt "`$XSLT_CONFIG --version`
 	echo
+	echo "libssh2 include directory:		$LIBSSH2_INCLUDE"
+	echo "libssh2 lib directory:			$LIBSSH2_LIB"
+	echo
 	if test "$HAVE_DATABASEDESIGNER" = yes
 	then
 		echo "Building Database Designer:		Yes"
diff --git a/configure.ac.in b/configure.ac.in
index e05eb0b..c466246 100644
--- a/configure.ac.in
+++ b/configure.ac.in
@@ -63,6 +63,15 @@ CHECK_LIBXML2
 LOCATE_LIBXSLT
 SETUP_LIBXSLT
 
+LOCATE_LIBSSH2
+SETUP_LIBSSH2
+CHECK_LIBSSH2_HANDSHAKE_FUNC
+AM_CONDITIONAL([HAVE_LIBSSH2_HANDSHAKE_FUNC], [test x$HAVE_LIBSSH2_HANDSHAKE_FUNC = xyes])
+CHECK_LIBSSH2_EXIT_FUNC
+AM_CONDITIONAL([HAVE_LIBSSH2_EXIT_FUNC], [test x$HAVE_LIBSSH2_EXIT_FUNC = xyes])
+CHECK_LIBSSH2_CRYPTO_LIBRARY
+AM_CONDITIONAL([IS_LIBSSH2_OPENSSL_CRYPTO], [test x$IS_LIBSSH2_OPENSSL_CRYPTO = xyes])
+
 LOCATE_SPHINX
 AM_CONDITIONAL([SPHINX_BUILD], [test x$SPHINX_BUILD != x])
 
diff --git a/pgadmin/Makefile.am b/pgadmin/Makefile.am
index 9af9354..ba5fbd3 100644
--- a/pgadmin/Makefile.am
+++ b/pgadmin/Makefile.am
@@ -65,6 +65,18 @@ else
   __EDB_LIBPQ=
 endif
 
+if IS_LIBSSH2_OPENSSL_CRYPTO
+  __IS_LIBSSH2_CYRPTO=-DIS_LIBSSH2_OPENSSL_CRYPTO
+endif
+
+if HAVE_LIBSSH2_EXIT_FUNC
+  __HAVE_LIBSSH2_EXIT_FUNC=-DHAVE_LIBSSH2_EXIT_FUNC
+endif
+
+if HAVE_LIBSSH2_HANDSHAKE_FUNC
+  __HAVE_LIBSSH2_HANDSHAKE_FUNC=-DHAVE_LIBSSH2_HANDSHAKE_FUNC
+endif
+
 if !APPBUNDLE
 
 nobase_dist_pkgdata_DATA = \
@@ -76,7 +88,7 @@ nobase_dist_pkgdata_DATA += \
 	$(TMP_ui)
 endif
 
-AM_CPPFLAGS = -DDATA_DIR=\"$(pkgdatadir)/\" -I$(top_srcdir)/pgadmin/include $(__CPPFLAGS) $(__EDB_LIBPQ)
+AM_CPPFLAGS = -DDATA_DIR=\"$(pkgdatadir)/\" -I$(top_srcdir)/pgadmin/include $(__CPPFLAGS) $(__EDB_LIBPQ) $(__IS_LIBSSH2_CYRPTO) $(__HAVE_LIBSSH2_EXIT_FUNC) $(__HAVE_LIBSSH2_HANDSHAKE_FUNC)
 
 # Automake trys to execute install-exec-hook if it appears anywhere in the file, so we need a dummy
 # for non-APPBUNDLE cases.
diff --git a/pgadmin/dlg/dlgServer.cpp b/pgadmin/dlg/dlgServer.cpp
index 2839480..7f4ac6d 100644
--- a/pgadmin/dlg/dlgServer.cpp
+++ b/pgadmin/dlg/dlgServer.cpp
@@ -54,6 +54,15 @@
 #define pickerSSLCrl      CTRL_FILEPICKER("pickerSSLCrl")
 #define chkSSLCompression CTRL_CHECKBOX("chkSSLCompression")
 
+#define chkSSHTunnel		 CTRL_CHECKBOX("chkSSHTunnel")
+#define txtTunnelHost		 CTRL_TEXT("txtTunnelHost")
+#define txtTunnelUsername	 CTRL_TEXT("txtTunnelUsername")
+#define radioBtnPassword	 CTRL_RADIOBUTTON("radioBtnPassword")
+#define radioBtnKeyfile      CTRL_RADIOBUTTON("radioBtnKeyfile")
+#define txtTunnelPassword	 CTRL_TEXT("txtTunnelPassword")
+#define pickerPublicKeyFile	 CTRL_FILEPICKER("pickerPublicKeyFile")
+#define pickerIdentityFile	 CTRL_FILEPICKER("pickerIdentityFile")
+#define stPublicKeyFile		 CTRL_STATIC("stPublicKeyFile")
 
 BEGIN_EVENT_TABLE(dlgServer, dlgProperty)
 	EVT_NOTEBOOK_PAGE_CHANGED(XRCID("nbNotebook"),     dlgServer::OnPageSelect)
@@ -80,6 +89,9 @@ BEGIN_EVENT_TABLE(dlgServer, dlgProperty)
 	EVT_COMBOBOX(XRCID("cbGroup"),                     dlgProperty::OnChange)
 	EVT_CHECKBOX(XRCID("chkSSLCompression"),           dlgProperty::OnChange)
 	EVT_BUTTON(wxID_OK,                                dlgServer::OnOK)
+	EVT_CHECKBOX(XRCID("chkSSHTunnel"),                dlgServer::OnCheckSSHTunnel)
+	EVT_RADIOBUTTON(XRCID("radioBtnPassword"),         dlgServer::OnChangeAuthOption)
+	EVT_RADIOBUTTON(XRCID("radioBtnKeyfile"),          dlgServer::OnChangeAuthOption)
 END_EVENT_TABLE();
 
 
@@ -134,6 +146,15 @@ dlgServer::dlgServer(pgaFactory *f, frmMain *frame, pgServer *node)
 			groupitem = browser->GetNextChild(browser->GetRootItem(), groupcookie);
 		}
 	}
+
+	EnableSSHTunnelControls(false);
+	radioBtnPassword->SetValue(true);
+	radioBtnKeyfile->SetValue(false);
+
+#ifdef IS_LIBSSH2_OPENSSL_CRYPTO
+	stPublicKeyFile->Show(false);
+	pickerPublicKeyFile->Show(false);
+#endif
 }
 
 
@@ -197,6 +218,13 @@ void dlgServer::OnOK(wxCommandEvent &ev)
 		server->SetSSLRootCert(pickerSSLRootCert->GetPath());
 		server->SetSSLCrl(pickerSSLCrl->GetPath());
 		server->iSetSSLCompression(chkSSLCompression->GetValue());
+		server->iSetSSHTunnel(chkSSHTunnel->GetValue());
+		server->SetTunnelHost(txtTunnelHost->GetValue());
+		server->SetTunnelUserName(txtTunnelUsername->GetValue());
+		server->iSetAuthModePwd(radioBtnPassword->GetValue());
+		server->SetTunnelPassword(txtTunnelPassword->GetValue());
+		server->SetPublicKeyFile(pickerPublicKeyFile->GetPath());
+		server->SetIdentityFile(pickerIdentityFile->GetPath());
 		wxColour colour = colourPicker->GetColour();
 		wxString sColour = colour.GetAsString(wxC2S_HTML_SYNTAX);
 		server->iSetColour(sColour);
@@ -225,7 +253,14 @@ void dlgServer::OnOK(wxCommandEvent &ev)
 			    server->GetRestore(),
 			    server->GetSSL(),
 			    server->GetColour(),
-			    server->GetGroup());
+			    server->GetGroup(),
+			    server->GetSSHTunnel(),
+			    server->GetTunnelHost(),
+			    server->GetTunnelUserName(),
+			    server->GetAuthModePwd(),
+			    server->GetTunnelPassword(),
+			    server->GetPublicKeyFile(),
+			    server->GetIdentityFile());
 			newserver->iSetDbRestriction(server->GetDbRestriction().Trim());
 			newserver->iSetServiceID(server->GetServiceID().Trim());
 			newserver->iSetDiscoveryID(server->GetDiscoveryID().Trim());
@@ -413,6 +448,23 @@ int dlgServer::Go(bool modal)
 
 		chkSSLCompression->SetValue(server->GetSSLCompression());
 
+		chkSSHTunnel->SetValue(server->GetSSHTunnel());
+		txtTunnelHost->SetValue(server->GetTunnelHost());
+		txtTunnelUsername->SetValue(server->GetTunnelUserName());
+		if (server->GetAuthModePwd())
+		{
+			radioBtnPassword->SetValue(true);
+			radioBtnKeyfile->SetValue(false);
+		}
+		else
+		{
+			radioBtnPassword->SetValue(false);
+			radioBtnKeyfile->SetValue(true);
+		}
+		txtTunnelPassword->SetValue(server->GetTunnelPassword());
+		pickerPublicKeyFile->SetPath(server->GetPublicKeyFile());
+		pickerIdentityFile->SetPath(server->GetIdentityFile());
+
 		stPassword->Disable();
 		txtPassword->Disable();
 		if (connection)
@@ -438,6 +490,17 @@ int dlgServer::Go(bool modal)
 			pickerSSLCrl->Disable();
 			chkSSLCompression->Disable();
 			EnableOK(false);
+			chkSSHTunnel->Enable(false);
+			EnableSSHTunnelControls(false);
+		}
+		else
+		{
+			if (server->GetSSHTunnel())
+			{
+				chkSSHTunnel->Enable(true);
+				EnableSSHTunnelControls(true);
+				EnableAuthenticationOptions();
+			}
 		}
 	}
 	else
@@ -467,13 +530,30 @@ wxString dlgServer::GetPassword()
 pgObject *dlgServer::CreateObject(pgCollection *collection)
 {
 	wxString name = GetName();
+	pgServer *obj = NULL;
 
-	pgServer *obj = new pgServer(GetName(), txtHostAddr->GetValue(), txtDescription->GetValue(),
-	                             txtService->GetValue(), cbDatabase->GetValue(),
-	                             txtUsername->GetValue(), StrToLong(txtPort->GetValue()),
-	                             chkTryConnect->GetValue() && chkStorePwd->GetValue(),
-	                             txtRolename->GetValue(), chkRestore->GetValue(), cbSSL->GetCurrentSelection(),
-	                             colourPicker->GetColourString(), cbGroup->GetValue());
+	if (chkSSHTunnel->GetValue())
+	{
+		obj = new pgServer(GetName(), txtHostAddr->GetValue(), txtDescription->GetValue(),
+		                   txtService->GetValue(), cbDatabase->GetValue(),
+		                   txtUsername->GetValue(), StrToLong(txtPort->GetValue()),
+		                   chkTryConnect->GetValue() && chkStorePwd->GetValue(),
+		                   txtRolename->GetValue(), chkRestore->GetValue(), cbSSL->GetCurrentSelection(),
+		                   colourPicker->GetColourString(), cbGroup->GetValue(),
+		                   chkSSHTunnel->GetValue(), txtTunnelHost->GetValue(), txtTunnelUsername->GetValue(),
+		                   radioBtnPassword->GetValue(),
+		                   txtTunnelPassword->GetValue(), pickerPublicKeyFile->GetPath(),
+		                   pickerIdentityFile->GetPath());
+	}
+	else
+	{
+		obj = new pgServer(GetName(), txtHostAddr->GetValue(), txtDescription->GetValue(),
+		                   txtService->GetValue(), cbDatabase->GetValue(),
+		                   txtUsername->GetValue(), StrToLong(txtPort->GetValue()),
+		                   chkTryConnect->GetValue() && chkStorePwd->GetValue(),
+		                   txtRolename->GetValue(), chkRestore->GetValue(), cbSSL->GetCurrentSelection(),
+		                   colourPicker->GetColourString(), cbGroup->GetValue());
+	}
 
 	obj->iSetDbRestriction(txtDbRestriction->GetValue().Trim());
 
@@ -550,3 +630,46 @@ wxString dlgServer::GetSql()
 {
 	return wxEmptyString;
 }
+
+void dlgServer::OnCheckSSHTunnel(wxCommandEvent &ev)
+{
+	if (chkSSHTunnel->IsChecked())
+	{
+		EnableSSHTunnelControls(true);
+		EnableAuthenticationOptions();
+	}
+	else
+	{
+		EnableSSHTunnelControls(false);
+	}
+}
+
+void dlgServer::OnChangeAuthOption(wxCommandEvent &ev)
+{
+	EnableAuthenticationOptions();
+}
+
+void dlgServer::EnableSSHTunnelControls(const bool& bEnable)
+{
+	txtTunnelHost->Enable(bEnable);
+	txtTunnelUsername->Enable(bEnable);
+	pickerPublicKeyFile->Enable(bEnable);
+	pickerIdentityFile->Enable(bEnable);
+	radioBtnPassword->Enable(bEnable);
+	radioBtnKeyfile->Enable(bEnable);
+	txtTunnelPassword->Enable(bEnable);
+}
+
+void dlgServer::EnableAuthenticationOptions()
+{
+	if (radioBtnPassword->GetValue())
+	{
+		pickerIdentityFile->Enable(false);
+		pickerPublicKeyFile->Enable(false);
+	}
+	else
+	{
+		pickerIdentityFile->Enable(true);
+		pickerPublicKeyFile->Enable(true);
+	}
+}
diff --git a/pgadmin/frm/frmMain.cpp b/pgadmin/frm/frmMain.cpp
index 12a9e1e..d3ef8bc 100644
--- a/pgadmin/frm/frmMain.cpp
+++ b/pgadmin/frm/frmMain.cpp
@@ -1195,6 +1195,13 @@ void frmMain::StoreServers()
 					settings->Write(key + wxT("SSLRootCert"), server->GetSSLRootCert());
 					settings->Write(key + wxT("SSLCrl"), server->GetSSLCrl());
 					settings->WriteBool(key + wxT("SSLCompression"), server->GetSSLCompression());
+					settings->WriteBool(key + wxT("SSHTunnel"), server->GetSSHTunnel());
+					settings->Write(key + wxT("TunnelHost"), server->GetTunnelHost());
+					settings->Write(key + wxT("TunnelUserName"), server->GetTunnelUserName());
+					settings->WriteBool(key + wxT("TunnelModePwd"), server->GetAuthModePwd());
+					settings->Write(key + wxT("TunnelPassword"), server->GetTunnelPassword());
+					settings->Write(key + wxT("PublicKeyFile"), server->GetPublicKeyFile());
+					settings->Write(key + wxT("IdentityFile"), server->GetIdentityFile());
 
 					pgCollection *coll = browser->FindCollection(databaseFactory, server->GetId());
 					if (coll)
diff --git a/pgadmin/include/dlg/dlgServer.h b/pgadmin/include/dlg/dlgServer.h
index 0fd8f33..71b4dad 100644
--- a/pgadmin/include/dlg/dlgServer.h
+++ b/pgadmin/include/dlg/dlgServer.h
@@ -46,6 +46,11 @@ private:
 	void OnPageSelect(wxNotebookEvent &event);
 	void OnChangeColour(wxColourPickerEvent &ev);
 	void OnChangeFile(wxFileDirPickerEvent &ev);
+	void OnCheckSSHTunnel(wxCommandEvent &ev);
+	void OnChangeAuthOption(wxCommandEvent &ev);
+
+	void EnableSSHTunnelControls(const bool& bEnable);
+	void EnableAuthenticationOptions();
 
 	DECLARE_EVENT_TABLE()
 };
diff --git a/pgadmin/include/pgAdmin3.h b/pgadmin/include/pgAdmin3.h
index 7a9bbdd..9a0f61d 100644
--- a/pgadmin/include/pgAdmin3.h
+++ b/pgadmin/include/pgAdmin3.h
@@ -19,6 +19,10 @@
 #include <wx/listctrl.h>
 #include <wx/xrc/xmlres.h>
 
+#ifdef WIN32
+#include <winsock2.h>
+#endif
+
 #include "utils/misc.h"
 #include <ctl/ctlTree.h>
 #include "ctl/ctlSQLBox.h"
diff --git a/pgadmin/include/schema/pgServer.h b/pgadmin/include/schema/pgServer.h
index c73cec3..0492e40 100644
--- a/pgadmin/include/schema/pgServer.h
+++ b/pgadmin/include/schema/pgServer.h
@@ -17,7 +17,7 @@
 
 
 class frmMain;
-
+class CSSHTunnelThread;
 
 class pgServerFactory : public pgaFactory
 {
@@ -41,7 +41,12 @@ extern pgServerFactory serverFactory;
 class pgServer : public pgObject
 {
 public:
-	pgServer(const wxString &newServer = wxT(""), const wxString &newHostAddr = wxT(""), const wxString &newDescription = wxT(""), const wxString &newService = wxT(""), const wxString &newDatabase = wxT(""), const wxString &newUsername = wxT(""), int newPort = 5432, bool storePwd = false, const wxString &newRolename = wxT(""), bool restore = true, int sslMode = 0, const wxString &colour = wxSystemSettings::GetColour(wxSYS_COLOUR_WINDOW).GetAsString(wxC2S_HTML_SYNTAX), const wxString &group = wxEmptyString);
+	pgServer(const wxString &newServer = wxT(""), const wxString &newHostAddr = wxT(""), const wxString &newDescription = wxT(""),
+		const wxString &newService = wxT(""), const wxString &newDatabase = wxT(""), const wxString &newUsername = wxT(""), int newPort = 5432,
+		bool storePwd = false, const wxString &newRolename = wxT(""), bool restore = true, int sslMode = 0,
+		const wxString &colour = wxSystemSettings::GetColour(wxSYS_COLOUR_WINDOW).GetAsString(wxC2S_HTML_SYNTAX), const wxString &group = wxEmptyString,
+		bool sshTunnel = false, const wxString &newTunnelHost = wxEmptyString, const wxString &newTunnelUserName = wxEmptyString, bool authModePwd = true,
+		const wxString &newTunnelPassword = wxEmptyString, const wxString &newPublicKey = wxEmptyString, const wxString &newIdentityFile = wxEmptyString);
 	~pgServer();
 	int GetIconId();
 
@@ -433,11 +438,86 @@ public:
 		sslcompression = b;
 	}
 
+	//SSH Tunnel
+	bool GetSSHTunnel() const
+	{
+		return sshTunnel;
+	}
+	void iSetSSHTunnel(const bool b)
+	{
+		sshTunnel = b;
+	}
+	bool GetAuthModePwd() const
+	{
+		return authModePwd;
+	}
+	void iSetAuthModePwd(const bool b)
+	{
+		authModePwd = b;
+	}
+	wxString GetLocalListenHost() const
+	{
+		return local_listenhost;
+	}
+	void SetLocalListenHost(const wxString &s)
+	{
+		local_listenhost = s;
+	}
+	int GetLocalListenPort() const
+	{
+		return local_listenport;
+	}
+	void SetLocalListenPort(int newVal)
+	{
+		local_listenport = newVal;
+	}
+	wxString GetTunnelHost() const
+	{
+		return tunnelHost;
+	}
+	void SetTunnelHost(const wxString &s)
+	{
+		tunnelHost = s;
+	}
+	wxString GetTunnelUserName() const
+	{
+		return tunnelUserName;
+	}
+	void SetTunnelUserName(const wxString &s)
+	{
+		tunnelUserName = s;
+	}
+	wxString GetTunnelPassword() const
+	{
+		return tunnelPassword;
+	}
+	void SetTunnelPassword(const wxString &s)
+	{
+		tunnelPassword = s;
+	}
+	wxString GetPublicKeyFile() const
+	{
+		return publicKeyFile;
+	}
+	void SetPublicKeyFile(const wxString &s)
+	{
+		publicKeyFile = s;
+	}
+	wxString GetIdentityFile() const
+	{
+		return identityFile;
+	}
+	void SetIdentityFile(const wxString &s)
+	{
+		identityFile = s;
+	}
+
 	void ShowDependencies(frmMain *form, ctlListView *Dependencies, const wxString &where = wxEmptyString);
 	void ShowDependents(frmMain *form, ctlListView *referencedBy, const wxString &where = wxEmptyString);
 
 private:
 	wxString passwordFilename();
+	bool createSSHTunnel();
 
 	pgConn *conn;
 	long serverIndex;
@@ -460,6 +540,12 @@ private:
 	wxString receiveLoc, replayLoc, replayTimestamp;
 	wxDateTime confLoadedSince;
 
+	//SSH Tunnel
+	CSSHTunnelThread *tunnelObj;
+	bool sshTunnel, authModePwd;
+	int local_listenport;
+	wxString tunnelHost, tunnelUserName, tunnelPassword, publicKeyFile, identityFile, local_listenhost;
+
 #ifdef WIN32
 	SC_HANDLE scmHandle;
 	SC_HANDLE serviceHandle;
@@ -602,4 +688,4 @@ public:
 	bool CheckEnable(pgObject *obj);
 };
 
-#endif
+#endif
\ No newline at end of file
diff --git a/pgadmin/include/utils/module.mk b/pgadmin/include/utils/module.mk
index bdc8ba4..3d18e95 100644
--- a/pgadmin/include/utils/module.mk
+++ b/pgadmin/include/utils/module.mk
@@ -22,7 +22,8 @@ pgadmin3_SOURCES += \
 	$(srcdir)/include/utils/sysProcess.h \
 	$(srcdir)/include/utils/sysSettings.h \
 	$(srcdir)/include/utils/utffile.h \
-	$(srcdir)/include/utils/macros.h
+	$(srcdir)/include/utils/macros.h \
+	$(srcdir)/include/utils/sshTunnel.h 
 
 EXTRA_DIST += \
         $(srcdir)/include/utils/module.mk
diff --git a/pgadmin/include/utils/sshTunnel.h b/pgadmin/include/utils/sshTunnel.h
new file mode 100644
index 0000000..860c184
--- /dev/null
+++ b/pgadmin/include/utils/sshTunnel.h
@@ -0,0 +1,104 @@
+//////////////////////////////////////////////////////////////////////////
+//
+// pgAdmin III - PostgreSQL Tools
+//
+// Copyright (C) 2002 - 2012, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+// sshTunnel.h - Used to create SSH Tunnel
+//
+//////////////////////////////////////////////////////////////////////////
+
+
+#ifndef __SSH_TUNNELING
+#define __SSH_TUNNELING
+
+#ifdef WIN32
+#include <ws2tcpip.h>
+#undef ssize_t
+#define ssize_t SSIZE_T
+#else
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include <arpa/inet.h>
+#include <sys/time.h>
+#include <netdb.h>
+#include <errno.h>
+#endif
+
+#include <libssh2.h>
+
+#include <wx/wx.h>
+#include <wx/thread.h>
+#include <wx/arrstr.h>
+#include <wx/arrimpl.cpp>
+
+enum enAuthenticationMethod
+{
+	AUTH_NONE = 0,
+	AUTH_PASSWORD,
+	AUTH_PUBLICKEY
+};
+
+class CSSHTunnelThread :
+		public wxThread
+{
+public:
+	CSSHTunnelThread(const wxString tunnelhost, const wxString remote_desthost, const unsigned int remote_destport,
+	                 const wxString username, const wxString password, const wxString publickey, const wxString privatekey,
+	                 const enAuthenticationMethod& enAuthMethod);
+	virtual ~CSSHTunnelThread(void);
+	virtual void *Entry();
+	bool Initialize();
+	void Cleanup();
+
+	wxString GetLocalListenIP() const
+	{
+		return m_local_listenip;
+	}
+
+	unsigned int GetLocalListenPort() const
+	{
+		return m_local_listenport;
+	}
+
+private:
+	long resolveDNS(const char * host, wxArrayString &arrIPAddress);
+
+	int m_listensock, m_sock, m_forwardsock;
+	struct sockaddr_in m_sin;
+	socklen_t m_sinlen;
+	LIBSSH2_CHANNEL *m_channel;
+	LIBSSH2_SESSION *m_session;
+
+	wxString m_publickey;
+	wxString m_privatekey;
+	wxString m_username;
+	wxString m_password;
+	wxString m_tunnelhost;
+	wxString m_local_listenip;
+	wxString m_remote_desthost;
+	unsigned int m_local_listenport;
+	unsigned int m_remote_destport;
+	enAuthenticationMethod m_enAuthMethod;
+};
+
+class CSubThread :
+		public wxThread
+{
+public:
+	CSubThread(const struct sockaddr_in sin, const wxString remote_desthost, const unsigned int remote_destport,
+	           LIBSSH2_SESSION *session, LIBSSH2_CHANNEL *channel, int forwardsock);
+	virtual ~CSubThread(void);
+	virtual void *Entry();
+
+private:
+	struct sockaddr_in m_sin;
+	wxString m_remote_desthost;
+	unsigned int m_remote_destport;
+	LIBSSH2_SESSION *m_session;
+	LIBSSH2_CHANNEL *m_channel;
+	int m_forwardsock;
+};
+
+#endif
